' UKTV v3.0 With Link Support (by Fiendish1)
'
' Description: Displays the 3 current/next TV programs and emmission times for English or Scottish TV (not Sky). These can optionally
'              be clickable whereby double clicking on a programme name will take you to the programme's description.
'
' **NOTE ** Due to a current limitation with Link support in Samurize, if you enable Links (see below) then you will
'           have to create a separate TextFile Meter per programme item (ie, you can only read in 1 line at a time from
'           the textfile)
'
'           If you disable Link support then you can read in as many lines from the textfile as you like with one or more
'           TextFile Meters
'
' This script creates a textfile (UKTV.TXT) that can be read in via TextFile Meters. The TextFile (UKTV.TXT) 
' is normally created in the Samurize folder.
'
' Usage Instructions:
'
' 1. Copy "UKTV.vbs" into your Samurize Scripts folder.
' 2. Add an active script to your Samurize Config and select "UKTV.vbs"
'    Select the RefreshData function, set it to run when you want (e.g. every 10 mins)
' 3. Add a Text File Meter and point it to the uktv.txt file (normally in your Samurize Folder)
'    Choose which lines you want to read in. The format of the Textfile is as follows:
'
'       Line 1, Line 5, Line 9, Line 13 & Line 17 are the Channel Names (e.g BBC1, ITV1, etc)
'       Line 2-4 are the 3 BBC1 programs and emmission start times.
'       Line 6-8 are the 3 BBC2 programs and emmission start times.
'       Line 10-12 are the 3 ITV1 programs and emmission start times.
'       Line 14-16 are the 3 CHANNEL 4 programs and emmission start times.
'       Line 18-20 are the 3 CHANNEL 5 programs and emmission start times.   
'
' NOTE: This script will take between 20 and 40 seconds to run.
'
'  ** CONFIG SECTION **
'
Links = True    ' Set to True to enable Link Support; False to disable Link Support.
Country = "England"   ' Set to England or Scotland
'
' ****************************
' DO NOT TOUCH BELOW THIS LINE - You have been warned !!!!!!
'*****************************

Function RefreshData

Randomize
If Country = "Scotland" Then
  GetURL = "http://www.radiotimes.beeb.com/ListingsServlet?event=4&channels=101,113,37,132,134&broadcastType=1&jspGridLocation=/jsp/tv_listings_multi.jsp&jspListLocation=/jsp/tv_listings_single.jsp&jspError=/jsp/error.jsp&allDay=true" & "&random=" & Rnd
Else
  GetURL = "http://www.radiotimes.beeb.com/ListingsServlet?event=12&broadcastType=1&jspGridLocation=/jsp/tv_listings_multi.jsp&jspListLocation=/jsp/tv_listings_single.jsp&jspError=/jsp/error.jsp&allDay=true" & "&random=" & Rnd
End If

Dim Http
	
Set Http = CreateObject("Microsoft.XMLhttp")
Http.Open "GET",GetURL,False
Http.Send
HtmlResult = BinToText(Http.ResponseBody, 35000)
Set Http = Nothing

If GetHTMLValue2("<title>", "</title>", HtmlResult,1) = "Radio Times - The best thing on TV, Film and Radio." Then checkright = "OK" Else checkright = "NOK"
Count = 1
BBC1Count = 0
BBC2Count = 0
ITV1Count = 0
CH4Count = 0
Ch5Count = 0

Dim BBC1(3)
Dim BBC2(3)
Dim ITV1(3)
Dim CH4(3)
Dim CH5(3)

Do

RawText = GetHTMLValue2("&stringTime=", "', ", htmlresult, count)

InfoArray = Split(RawText, "&")

ProgTime = InfoArray(0)
If Len(ProgTime) = 6 then ProgTime = "0" & ProgTime
ProgTitle =  Replace(InfoArray(2), "title=", "")
ChannelName = Replace(InfoArray(3), "channelName=", "")

ProgTitle = Replace(ProgTitle, "~", "'")
If Links Then
  RawLink = GetHTMLValue2("<td class=""bluetext"" width=""100%"" valign=""top"">", "', ", htmlresult, count)
  RawLink = Mid(RawLink, Instr(Rawlink, "?src=") + 12)
  RawLink = Replace(RawLink, ":80", "")
  ProgTitle = ProgTitle & "%l" & RawLink
End If

If ChannelName = "BBC1 Scotland" OR ChannelName = "BBC1" then
  BBC1Count = BBC1Count + 1
  If BBC1Count <= 3 Then
    BBC1(BBC1Count - 1) = ProgTime & " - " & ProgTitle & vbNewLine
  End If
End If

If ChannelName = "BBC2 Scotland" OR ChannelName = "BBC2" then
  BBC2Count = BBC2Count + 1
  If BBC2Count <= 3 Then
    BBC2(BBC2Count - 1) = ProgTime & " - " & ProgTitle & vbNewLine
  End If
End If

If ChannelName = "Scottish" OR ChannelName = "ITV1 London" then
  ITV1Count = ITV1Count + 1
  If ITV1Count <= 3 Then 
    ITV1(ITV1Count - 1) = ProgTime & " - " & ProgTitle & vbNewLine
  End If
End If

If ChannelName = "Channel 4" then
  CH4Count = CH4Count + 1
  If CH4Count <= 3 Then 
    CH4(CH4Count - 1) = ProgTime & " - " & ProgTitle & vbNewLine
  End If
End If

If ChannelName = "Five" then
  CH5Count = CH5Count + 1
  If CH5Count <= 3 Then 
    CH5(CH5Count - 1) = ProgTime & " - " & ProgTitle & vbNewLine
  End If
  If CH5Count = 4 Then Exit Do
End If

Count = Count + 1
Loop

Set fs=CreateObject("Scripting.FileSystemObject")
Set f=fs.CreateTextFile("UKTV.txt",true)

If Country = "Scotland" Then f.Write "BBC1 Scotland" & VbNewLine Else f.Write "BBC1" & VbNewLine
If BBC1(0) <> "" Then f.Write BBC1(0) Else f.Write "No Data Available" & VbNewLine
If BBC1(1) <> "" Then f.Write BBC1(1) Else f.Write "No Data Available" & VbNewLine
If BBC1(2) <> "" Then f.Write BBC1(2) Else f.Write "No Data Available" & VbNewLine

If Country = "Scotland" Then f.Write "BBC2 Scotland" & VbNewLine Else f.Write "BBC2" & VbNewLine
If BBC2(0) <> "" Then f.Write BBC2(0) Else f.Write "No Data Available" & VbNewLine
If BBC2(1) <> "" Then f.Write BBC2(1) Else f.Write "No Data Available" & VbNewLine
If BBC2(2) <> "" Then f.Write BBC2(2) Else f.Write "No Data Available" & VbNewLine

If Country = "Scotland" Then f.Write "Scottish" & VbNewLine Else f.Write "ITV1" & VbNewLine
If ITV1(0) <> "" Then f.Write ITV1(0) Else f.Write "No Data Available" & VbNewLine
If ITV1(1) <> "" Then f.Write ITV1(1) Else f.Write "No Data Available" & VbNewLine
If ITV1(2) <> "" Then f.Write ITV1(2) Else f.Write "No Data Available" & VbNewLine

f.Write "Channel 4" & VbNewLine
If CH4(0) <> "" Then f.Write CH4(0) Else f.Write "No Data Available" & VbNewLine
If CH4(1) <> "" Then f.Write CH4(1) Else f.Write "No Data Available" & VbNewLine
If Ch4(2) <> "" Then f.Write Ch4(2) Else f.Write "No Data Available" & VbNewLine

f.Write "Five" & VbNewLine
If CH5(0) <> "" Then f.Write CH5(0) Else f.Write "No Data Available" & VbNewLine
If CH5(1) <> "" Then f.Write CH5(1) Else f.Write "No Data Available" & VbNewLine
If Ch5(2) <> "" Then f.Write Ch5(2) Else f.Write "No Data Available" & VbNewLine

RefreshData = "TxtFile Written"

End Function

Private Function GetHTMLValue2(LeftBound, RightBound, htmlresult, count)
  HtmlStart = InStr(HtmlResult, LeftBound) + Len(LeftBound)
	HtmlEnd = InStr(HtmlStart, HtmlResult, RightBound)

	For counter = 2 To count
  	HtmlStart = InStr(HtmlEnd + Len(RightBound), HtmlResult, LeftBound) + Len(LeftBound) 
	  HtmlEnd = InStr(HtmlStart, HtmlResult, RightBound)
	Next

 	If HtmlStart > 0 AND HtmlEnd > 0 Then
	  GetHTMLValue2 = Replace(Mid(HtmlResult, HtmlStart, HtmlEnd - HtmlStart ), "&nbsp;", " ")
 	Else
 		GetHTMLValue2 = "N/A"
	End If
End Function

Private Function BinToText(varBinData, intDataSizeInBytes)    ' as String

	Const adFldLong = &H00000080
    Const adVarChar = 200
    Set objRS = CreateObject("ADODB.Recordset")

    objRS.Fields.Append "txt", adVarChar, intDataSizeInBytes, adFldLong
    objRS.Open

    objRS.AddNew
    objRS.Fields("txt").AppendChunk varBinData
    BinToText = objRS("txt").Value

    objRS.Close
    Set objRS = Nothing
End Function
